package OCTools;

import java.lang.reflect.Method;
import java.text.ParseException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.json.JSONException;
import org.json.JSONObject;

/**
 * json 1:JavaBeanתMapJSONObject 2:MapתJavabean
 * 3:JSONObjectתMapJavabean
 * 
 * @author MingChao Sun
 */

public class OCJsonWorker {

	/**
	 * JavabeanתΪMap
	 * 
	 * @param javaBean
	 *            javaBean
	 * @return Map
	 */
	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static Map toMap(Object javaBean) {

		Map result = new HashMap();
		Method[] methods = javaBean.getClass().getDeclaredMethods();

		for (Method method : methods) {

			try {

				if (method.getName().startsWith("get")) {

					String field = method.getName();
					field = field.substring(field.indexOf("get") + 3);
					field = field.toLowerCase().charAt(0) + field.substring(1);

					Object value = method.invoke(javaBean, (Object[]) null);
					result.put(field, null == value ? "" : value.toString());

				}

			} catch (Exception e) {
				e.printStackTrace();
			}

		}

		return result;

	}

	/**
	 * JsonתMap
	 * 
	 * @param jsonObject
	 *            json
	 * @return Map
	 * @throws JSONException
	 */
	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static Map toMap(String jsonString) throws JSONException {

		JSONObject jsonObject = new JSONObject(jsonString);

		Map result = new HashMap();
		Iterator iterator = jsonObject.keys();
		String key = null;
		String value = null;

		while (iterator.hasNext()) {

			key = (String) iterator.next();
			value = jsonObject.getString(key);
			result.put(key, value);

		}
		return result;

	}

	/**
	 * JavaBeanתJSONObjectͨMapת
	 * 
	 * @param bean
	 *            javaBean
	 * @return json
	 */
	public static JSONObject toJSON(Object bean) {

		return new JSONObject(toMap(bean));

	}

	/**
	 * MapתJavabean
	 * 
	 * @param javabean
	 *            javaBean
	 * @param data
	 *            Map
	 */
	@SuppressWarnings("rawtypes")
	public static Object toJavaBean(Object javabean, Map data) {

		Method[] methods = javabean.getClass().getDeclaredMethods();
		for (Method method : methods) {

			try {
				if (method.getName().startsWith("set")) {

					String field = method.getName();
					field = field.substring(field.indexOf("set") + 3);
					field = field.toLowerCase().charAt(0) + field.substring(1);
					method.invoke(javabean, new Object[] {

					data.get(field)

					});

				}
			} catch (Exception e) {
			}

		}

		return javabean;

	}

	/**
	 * JSONObjectJavaBean
	 * 
	 * @param bean
	 *            javaBean
	 * @return json
	 * @throws ParseException
	 *             json쳣
	 * @throws JSONException
	 */
	@SuppressWarnings("rawtypes")
	public static void toJavaBean(Object javabean, String jsonString)
			throws ParseException, JSONException {

		JSONObject jsonObject = new JSONObject(jsonString);

		Map map = toMap(jsonObject.toString());

		toJavaBean(javabean, map);

	}

	public static String BeanToJson(Object javabean) {

		// JavabeanתΪJsonݣҪMapת
		JSONObject jo = OCJsonWorker.toJSON(javabean);

		return jo.toString();
		
	}

}
